#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

#include "server_socket.h"

struct server_info* new_server_socket( int port )
  {
    struct server_info* back;

    back = ( struct server_info*) malloc ( sizeof ( struct server_info ) ) ;
    back->port = port;

    if ( ( back->socket = socket(AF_INET,SOCK_STREAM,0 ) ) > 0)
      printf("The socket was created\n");

    int one = 1;
    setsockopt(back->socket, SOL_SOCKET, SO_REUSEADDR, &one, sizeof(one));

    back->address.sin_family = AF_INET;
    back->address.sin_addr.s_addr = INADDR_ANY;
    back->address.sin_port = htons( back->port );

    return(back);
  }

 
int bind_socket( struct server_info *server)
  {
    if ( bind(server->socket,(struct sockaddr *)&(server->address),sizeof(struct sockaddr_in)) == 0)
      printf("Binding Socket\n");
    else
      return(-1);

    return ( 0 );
  }


int wait_for_client( struct server_info *server)
  {
    int addrlen;
    int new_socket;

    listen(server->socket, SOMAXCONN);
    addrlen = sizeof(struct sockaddr_in);
    new_socket = accept(server->socket,(struct sockaddr*)&(server->address),(socklen_t *)&addrlen);
    if (new_socket > 0)
      {
         printf("The Client %s is connected...\n",inet_ntoa(server->address.sin_addr));
      }

    return(new_socket);
  }

int close_server_socket ( struct server_info *server )
  {
    close(server->socket);
    free(server);
    return(0);
  }
